/*
 * Question.java
 *
 * Created on April 12, 2006, 5:36 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * @author haiyanw
 */

package activelearner;
import java.util.*;
        
public class Question {
    
    ActiveLearner.Arity arity;    // 1 one-place relation; 2 two-place relation
    /** This is the array holding relations we will ask as items in the multiple choice question. **/
    List<String> possibleAnswers;
    String entity;
    Integer answer = null;


    public Question(ActiveLearner.Arity ar, String ent, List<String> rels) {
        this.possibleAnswers = new ArrayList(rels);
        this.arity = ar;
        this.entity = ent;
    }
    
    // Suppose the relationType=0; relation="City"; entity[]={"Pittsburgh","New York", "Phili"..}
    // then it will print out 5 questions: "Is Pittsburgh a City? Yes(0); No(1); Don't Know(2);"
    public String getQuestionString() 
    {
        String qString = "";
        
        if (arity==ActiveLearner.Arity.UNARY) {
            qString += "What best describes " + entity + "?" + "\n";
        } else if (arity==ActiveLearner.Arity.BINARY) {
            qString += "What best describes the relationship between " + 
                    entity + "?"  + "\n";
        } // else some exception
        
        //  Maybe this will be a checkbox implementation by UI.
        for (int j=0; j < possibleAnswers.size(); j++) {
            qString += "[" + (j+1) + "] " + possibleAnswers.get(j) + "\n"; 
        }
        
        return qString;
    }
    
    /* The bootstrapper should set answer with '1 ~ number of possible answers',
       i.e., using a 1-based system. */
    public void setAnswer(int ans) {
        this.answer = ans-1;
    }
    
    public String getEntity() {
        return entity;
    }
    public String getAnswer() {
        return possibleAnswers.get(answer);
    }

} // end of class Question